--- behaviorBase module
--- Created by: Mark Fainstein at: 04/19/15
-- @module behaviorBase

function behaviorBase(self)

 if not self._behaviorTarget then
  services:debugMessageBox("behaviorBase", "issue with self passed to behaviorBase module")
 end

  --- gets the id of this behavior
  -- @function getId
	function self.getId()
    return self._behaviorTarget:getTargetId()
 	end

  --- get an object
-- @function getObject
-- @param id
 function self.getObject(id)
  if not id then return end
  if self.getId() == id then return self._behaviorTarget end
  local obj = self._behaviorTarget:getTargetById(id)
  return obj
 end

 -- get a behavior, from a specific object
 -- @function getBehavior
 -- @param id
 -- @param behaviorName
  function self.getBehavior(id, behaviorName)
  local object = self.getObject(id)
  if object then
   return object:getBehavior(behaviorName)
  end
 end

 --- get an application behavior (which is attached to ttScenes)
 -- @function getApplicationBehavior
 -- @param behaviorName
 function self.getApplicationBehavior(behaviorName)
  if self.getId() == "ApplicationObject" then return self.getBehavior("ApplicationObject", behaviorName) end
  -- temporary workaround (!!!)
  -- TODO: remove this after it has been fixed
  return _G[behaviorName.."_ApplicationObject"]
 end

 --- bind a function with event
 -- @param event
 -- @param func the function to call on this event
 -- @param funcParams the parameters to pass to this function with the published params
 -- TODO: delete this ???
 function self.bindEvent(event, func, funcParams)
  self["on"..event] = function(...)
   local publishedParams = {...}
   local params = {}
   for i=1, #funcParams do
    table.insert(params, funcParams[i])
   end
   for i=1, #publishedParams do
    table.insert(params, publishedParams[i])
   end
   func(unpack(params))
  end
   PubSub.subscribeEvent(self, event)
 end

    --- unbind a function from an event
  -- @param event
  function self.unbindEvent(event)
   self["on"..event] = nil
   PubSub.unsubscribeEvent(self, event)
  end

	return self
end





