viewTranslation = {}
--- Private function: convert percentage to screen pixels
-- @function prcTo_w
-- @param w
-- @return screen pixels width
local isLandscape = vars:getFloatVar("isLandscape")

  local function prcTo_w(w)
    if isLandscape == 1 then
      return w*(1024/100)
    else
      return w*(768/100)
    end
  end

--- Private function: convert percentage to screen pixels
-- @function prcTo_h
-- @param h
-- @return screen pixels height
  local function prcTo_h(h)
    if isLandscape == 1 then
      return h*(768/100)
    else
      return h*(1024/100)
    end
  end

--- Private function: convert width to screen percentage
-- @function w_toPrc
-- @param w
-- @return percentage of w
  local function w_toPrc(w)
    if isLandscape == 1 then
      return (w/1024)*100
    else
      return (w/768)*100
    end
  end
--- Private function: convert height to screen percentage
-- @function h_toPrc
-- @param h
-- @return percentage of h
  local function h_toPrc(h)
    if isLandscape == 1 then
      return (h/768)*100
    else
      return (h/1024)*100
    end
  end
--- Private function: convert percentage width to screen pixesls
-- @function prcToLocX
-- @param x
-- @return secreen pixels of x
  local function prcToLocX(x)
    if isLandscape == 1 then
      return x*(100/1024)
    else
      return x*(100/768)
    end
  end

--- Private function: convert percentage height to screen pixesls
-- @function prcToLocX
-- @param y
-- @return percentage of y
  local function prcToLocY(y)
    if isLandscape == 1 then
      return y*(100/768)
    else
      return y*(100/1024)
    end
  end

  --export
  viewTranslation.prcTo_w = prcTo_w
  viewTranslation.prcTo_h = prcTo_h
  viewTranslation.w_toPrc = w_toPrc
  viewTranslation.h_toPrc = h_toPrc
  viewTranslation.prcToLocX = prcToLocX
  viewTranslation.prcToLocY = prcToLocY



