
rewards = {}
rewards.setConfig = function ()

r_persist = persistency:getPackagePersistency("rewardsPeristency")
r_config = getPackageConfig("rewards")

end

local function increasePlayedCount (itemId)
  if (r_persist:getValue (itemId.."playedCount") == nil) then
    r_persist:setValue(itemId.."playedCount", 1)
  else
  r_persist:setValue(itemId.."playedCount", r_persist:getValue (itemId.."playedCount") + 1)
  end
end

local function getPlayedCount (itemId)
  return r_persist:getValue (itemId.."playedCount")
end

local function setItemUnlocked (itemId)
  r_persist:setValue(itemId.."isUnlocked", 1)
end

local function setItemNewUnlock (itemId, imagePath, isTool)
  rewards.currentNewItem = itemId
  rewards.itemImagePath = imagePath
  rewards.isTool = isTool
end


local function getItemFromConfig (itemName)
  for i = 1, #r_config.tools  do
    if (itemName == r_config.tools[i].name) then
      return r_config.tools[i]
    end
  end
  return ""

end


local function getNextLockedDecoration ()
  local decorations = {}
  local c_decorations = {}
  local decorationCount = 0
  local foundCount = 0
  c_decorations = r_config.decorations

    local foundDecoration = {}
    for i = 1, #c_decorations  do
      if (rewards.isItemUnlocked (c_decorations[i].name) ~= 1) then
        foundCount = foundCount + 1
        decorations[foundCount] = c_decorations[i]
        if (foundCount == 3) then break end
        end
    end

    foundDecoration = decorations[math.random(1,#decorations)]

    if (foundDecoration ~= nil) then return foundDecoration else return c_decorations[math.random(1,#c_decorations)]
    end

end



function rewards.setItemPlayed (itemId, sceneId)
  rewards.currentItemPlayed = itemId
  rewards.sceneEntered = sceneId
end

function rewards.getSceneEntered ()
  if (rewards.isTool == true) then return "map" else return "slicingFactory"
  end
end

function rewards.itemSuccesful ()
  local itemId = getItemFromConfig (rewards.currentItemPlayed)
   if (itemId ~= "") then
      increasePlayedCount (itemId.name)
      local playedCount = getPlayedCount (itemId.name)
      local neededCount = itemId.neededCount
      if (playedCount >= neededCount) then
            setItemUnlocked (itemId.name)
            setItemNewUnlock (itemId.name,itemId.imagePath, true)
          else

          local decorationID = getNextLockedDecoration ()
            setItemUnlocked (decorationID.name)
            setItemNewUnlock (decorationID.name, decorationID.imagePath, false)
      end
    else
          local decorationID = getNextLockedDecoration ()
            setItemUnlocked (decorationID.name)
            setItemNewUnlock (decorationID.name, decorationID.imagePath, false)
  end


end

function rewards.isItemUnlocked (itemId)
  if (r_persist:getValue (itemId.."isUnlocked") == 1) then return 1 else return 0
  end
end

function rewards.setItemWon (itemId)
  setItemUnlocked (itemId)
end

function rewards.getNewWonItem()
  local newItemWon = {}
  newItemWon.name = rewards.currentNewItem
  newItemWon.imagePath = rewards.itemImagePath
  newItemWon.isTool = rewards.isTool
  return newItemWon
end

function rewards.doesItemExist ()
    if (rewards.currentItemPlayed == "" or rewards.currentItemPlayed == nil) then return 0 else return 1 end
end

function rewards.setFreePass(value)
    r_persist:setValue ("hasFreePass", value)
end

function rewards.getFreePass()
    return r_persist:getValue ("hasFreePass")
end

function rewards.reset()
  rewards.currentNewItem = ""
  for i = 1, 100 do
    r_persist:setValue ("level"..i.."tool".."isUnlocked", 0)
    r_persist:setValue ("level"..i.."Tool".."isUnlocked", 0)
    r_persist:setValue ("level"..i.."tool".."playedCount", 0)
    r_persist:setValue ("level"..i.."Tool".."playedCount", 0)
    r_persist:setValue ("decor"..i.."isUnlocked", 0)
    r_persist:setValue ("levelDecoration"..i.."isUnlocked", 0)
   end

    r_persist:setValue ("decor45", 0)
    r_persist:setValue ("decor46", 0)
end


 function rewards.availableDecorationExists ()
  local decorations = {}
  local c_decorations = {}
  local decorationCount = 0
  c_decorations = r_config.decorations

    for i = 1, #c_decorations  do
      if (rewards.isItemUnlocked (c_decorations[i].name) ~= 1) then
        return 1
        end
    end
    return 0
end

 function rewards.unlockAllItems ()
	for i = 1, #r_config.tools  do
		setItemUnlocked(r_config.tools[i].name)
	end
end


rewards.setConfig()