app = {}

app.init = function()
    if (app.m_initialized == nil) then
        print("########### Init")
        app.m_initialized   = true
--      model.debugmode()
        model.init()
--      inAppProduct_all_levels = 1
--      inAppProduct_pro_kit = 1
        if (not app.isHardGateOpen() and model.getCurrentLevel() == 6) then
            model.setSledCurrentLevel(5)
            model.setSledTargetLevel(5)
        end
    end
end

app.isInitialized = function()
    print("########### isInitialized ", tostring(not app.initialized == nil))
    return not app.initialized == nil
end



----------------------------------------------------------------------------
-- Map levels
----------------------------------------------------------------------------

app.isLevelComplete = function(level)
    if ((model.getCurrentLevel() > level) or model.isGameComplete()) then
        return true
    else
        return false
    end
end

app.isLevelAvailiable = function (level)
    -- level 6 and above open only if product3 purchased
    if ((level >=6) and (not app.isHardGateOpen())) then
        return false
    end

    if ((model.getCurrentLevel() >= level) and not app.isLevelComplete(level)) then
        print ("######## isLevelAvail true level:"..level)
        return true
    else
        return false
    end
end

app.isCurrentLevel = function (level)
    if (model.getCurrentLevel() == level) then
        return true
    else
        return false
    end
end


app.levelComplete = function (level)
    print("#### level complete")
    if (model.getCurrentLevel() <= level) then
        model.setCurrentLevel(level + 1)
        if ((not (level == 5)) or (app.isHardGateOpen())) then
            model.setFactoryOpen(true) -- open the factory
            model.setSledTargetLevel(level+1)
            app.setEnterLevelOnArrival(true)
        end
    end
    if (level == 11) then
        print("##### Game complete");
        model.setGameComplete(true)
--        model.setCurrentLevel(1)
--        model.setSledTargetLevel(1)
    --  model.setSledCurrentLevel(1)
    end
    app.setRewardWonOnLevelComplete(level)
end

app.isHardGateOpen = function ()
    return (app.isPurchasedMagicToolsKit() or
            app.isPurchasedLevelsKit() or
            app.isPurchasedAllKit())
end

app.shouldOpenInAppOnLevelSelection = function(level)
    -- inapp will popup only when level 5 is complete and hard gate is not already open
    if (app.isHardGateOpen()) then
        return false
    end
    return (app.isLevelComplete(5))
end

app.setInAppVariables = function()
    -- if user buy the prokit he gest all levels
    print ("#### app.setInAppVariables inAppProduct_pro_kit "..tostring(inAppProduct_pro_kit).." ")
    if (inAppProduct_pro_kit==1) then
        vars:setVar("inAppProduct_all_levels",1)
    end
end

----------------------------------------------------------------------------
-- Level Factory
----------------------------------------------------------------------------

app.getFactoryLevel = function()
    return model.getFactoryLevel()
end

app.isFactoryAvailable = function()
    -- Open if purchased
    if (app.isPurchasedMagicToolsKit() or
        app.isPurchasedAllKit()) then
        return true
    end
    -- The factory shows as availiable when completing level 5 and the hard gate closed
    if (not app.isHardGateOpen() and model.getCurrentLevel()>=6) then
        return true
    end
    return (model.getCurrentLevel() >= 4)
end

app.isFactoryOpen = function()
    -- If bought
    if (app.isPurchasedMagicToolsKit() or
        app.isPurchasedAllKit()) then
        return true
    end

    if ((not app.isHardGateOpen()) and model.getCurrentLevel()>=6) then
        return true
    end

    return (app.isFactoryAvailable() and model.isFactoryOpen()) or model.isGameComplete()
end

app.isFactoryClose = function()
    if (app.isPurchasedMagicToolsKit() or
        app.isPurchasedAllKit()) then
        return false
    end
    if ((not app.isHardGateOpen()) and model.getCurrentLevel()>=6) then
        return false
    end

    return (app.isFactoryAvailable() and (not model.isFactoryOpen()))
end

app.canDriveToFactory = function()
    if (app.isFactoryOpen() and not ((not app.isHardGateOpen()) and model.getCurrentLevel()>=6)) then
        return true
    end
    return false

end

----------------------------------------------------------------------------
-- Sled animation
----------------------------------------------------------------------------

app.shouldMoveBetweenLevels = function(fromLevel, toLevel)
    -- if sled in factory
    if (model.isSledInFactory()) then
        return false
    end

    -- if already arrived
    if (model.getSledTargetLevel() == model.getSledCurrentLevel()) then
        return false
    end
    -- if the current seld level
    if (not (fromLevel == model.getSledCurrentLevel())) then
        return false
    end
    -- if going up
    if (model.getSledTargetLevel() > model.getSledCurrentLevel()) and
       (fromLevel < toLevel) then
        print("##### shouldMoveBetweenLevels up from:"..fromLevel.." to:"..toLevel.." sledLevel:"..model.getSledCurrentLevel().." target:"..model.getSledTargetLevel())
        return true
    end
    -- if going down
    if (model.getSledTargetLevel() < model.getSledCurrentLevel()) and
        (fromLevel > toLevel) then
        print("##### shouldMoveBetweenLevels down from:"..fromLevel.." to:"..toLevel.." sledLevel:"..model.getSledCurrentLevel().." target:"..model.getSledTargetLevel())
        return true
    end

    return false
end

app.setEnterLevelOnArrival = function(level)
    print("#### app.setEnterLevelOnArrival ",level)
    model.m_enterOnArrival = level
end

app.isEnterLevelOnArrival = function()
    return model.m_enterOnArrival
end

app.setSledArrivedToLevel = function(level)
    print("##### setSledArrivedToLevel ",tostring(level))
    model.setSledCurrentLevel(level)
    model.setSledInFactory(false)
end

app.isSledTargetToLevel = function(level)
    return (model.getSledTargetLevel() == level)
end

app.setSledTargetFactory = function(val)
    model.setSledTargetCamera(false)
    if (val == true) then
        model.setFactoryOpen(true)
        -- first goto the level next to the factory
        if (model.getSledCurrentLevel() > 3) then
            model.setSledTargetLevel(4)
        else
            model.setSledTargetLevel(3)
        end
        if (not model.isSledInFactory()) then
            app.setEnterLevelOnArrival(true)
        end
    end
    model.setSledTargetToFactory(val)
end

app.setSledTargetLevel = function(level)
    model.setSledTargetCamera(false)
    model.setSledTargetLevel(level)
end

app.shouldMoveToFactoryFromLevel = function(fromLevel)
    ret = (model.isSledTargetToFactory() and (model.getSledCurrentLevel() == fromLevel) and not model.isSledInFactory())
    if (ret) then
        print ("###### app.shouldMoveToFactoryFromLevel level:"..fromLevel.." ret:"..tostring(ret))
        return ret
    end
    ret = model.isSledTargetToFactory() and (fromLevel == nil) and model.isSledInFactory()
    if (ret) then
        print ("###### app.shouldMoveToFactoryFromLevel should move from factory to factory")
        return ret
    end
    return ret
end

app.setSledInFactory = function(val)
    model.setSledInFactory(val)
end

app.shouldMoveToLevelFromFactory = function(toLevel)
    if (not model.isSledInFactory() or model.isSledTargetToFactory()) then
        return false
    end
    if (toLevel == 3) and (model.getSledTargetLevel() <= 3) then
        print ("###### app.shouldMoveToLevelFromFactory true level:"..toLevel)
        return true
    end
    if (toLevel == 4) and (model.getSledTargetLevel() >= 4) then
        print ("###### app.shouldMoveToLevelFromFactory true level:"..toLevel)
        return true
    end
    return false
end

app.isSledAtTargetLevel = function(level)
    ret =   (not model.isSledTargetToFactory()) and
            (not model.isSledInFactory()) and
            (model.getSledTargetLevel() == model.getSledCurrentLevel()) and
            ((model.getSledCurrentLevel() == level) or (level == nil))
--    print("### isSledAtTragetLevel level:"..tostring(level).." ret:"..tostring(ret).." isSledTargetToFactory:"..tostring(model.isSledTargetToFactory()).." isSledInFactory:"..tostring(model.isSledInFactory()).." getSledTargetLevel:"..model.getSledTargetLevel().." getSledCurrentLevel:"..model.getSledCurrentLevel())
    return ret
end

app.setSledTargetCamera = function(value)
    app.setEnterLevelOnArrival(false)
    app.setSledTargetLevel(10)
    model.setSledTargetCamera(value)
end

app.isSledTargetCamera = function()
    return model.isSledTargetCamera()
end

----------------------------------------------------------------------------
-- Rewards
----------------------------------------------------------------------------

app.getConfigData = function(tbl,row,column)
    idx = ConfigTables.Index:new(tbl,row,column)
    r,val = config:get(idx,v)
    return val
end

app.selectPresentForSelection = function(selection)
    print("##### present selected",tostring(selection))

    factoryLevel = model.getFactoryLevel()

    -- get the present ID
    idx = ConfigTables.Index:new("factoryRewards","level"..factoryLevel,"present"..selection)
    r,rewardName = config:get(idx,v)

    -- level up in factory
    if (factoryLevel<=15) then
        model.setFactoryLevel(factoryLevel+1)
    end

    -- if the present is a magic tool, close the factory
    isMagicTool = app.getConfigData("rewards",tostring(rewardName),"magicTool")
    rewardSequence  = app.getConfigData("rewards",tostring(rewardName),"imageSequenceNumber")
    print("##### is magic tool",tostring(rewardName),isMagicTool)
    if (isMagicTool == "true") then
        model.setFactoryOpen(false)
        model.setSledTargetLevel(model.getCurrentLevel())
        model.setWonMagicTool(true)
        app.setRewardWon(rewardName)
    else
        model.setWonMagicTool(false)
        app.setRewardWon(rewardName)
    end


    -- return the reward ID
    vars:setVar("selectedPresent",rewardSequence-1)
end

app.isWonMagicTool = function()
    print("####### app.isWonMagicTool")
    return model.isWonMagicTool()
end

app.isRewardAvailiable = function(rewardName)

    -- if purchased all kit open all rewards
    if (app.isPurchasedAllKit()) then
        print ("#### app.isRewardAvailiable return true due to all kits bought:")
        return true
    end

    -- if purchased product2 open only the decorations
    isMagicTool = (app.getConfigData("rewards",tostring(rewardName),"magicTool") == "true")
    if ((app.isPurchasedDecorationsKit()) and (not isMagicTool)) then
        print ("#### app.isRewardAvailiable return true due to decoration product:")
        return true
    end
    if ((app.isPurchasedMagicToolsKit()) and (isMagicTool)) then
        print ("#### app.isRewardAvailiable return true due to magic tools product:"..tostring(rewardName))
        return true
    end
    val = model.isRewardAvailiable(rewardName)
    print ("#### app.isRewardAvailiable return :"..tostring(rewardName))
    return val
end

app.setRewardWon = function(rewardName)
    model.setRewardWon(rewardName)

    -- test
    won = model.isRewardAvailiable(rewardName)
    if (won) then
        print("reward "..rewardName.." is set to Won")
    else
        print("reward "..rewardName.." is NOT set to Won")
    end
end

app.setRewardWonOnLevelComplete = function(level)
    print("app.setRewardWonOnLevelComplete level:"..tostring(level))
    idx = ConfigTables.Index:new("levelRewards","level"..level,"reward")
    r,rewardName = config:get(idx,v)
    print("app.setRewardWonOnLevelComplete reward name is :"..rewardName)
    rewardSequence  = app.getConfigData("rewards",tostring(rewardName),"imageSequenceNumber")
    app.setRewardWon(rewardName)
    print("app.setRewardWonOnLevelComplete reward sequence is :"..rewardSequence)
    vars:setVar("selectedPresent",rewardSequence-1)
end


----------------------------------------------------------------------------
-- InApp
----------------------------------------------------------------------------

app.isPurchasedMagicToolsKit = function()
    return (inAppProduct_pro_kit ~= nil) and (inAppProduct_pro_kit==1)
end

app.isPurchasedDecorationsKit = function()
    return (inAppProduct_decoration ~= nil) and (inAppProduct_decoration==1)
end

app.isPurchasedLevelsKit = function()
    return (inAppProduct_all_levels ~= nil) and (inAppProduct_all_levels==1)
end

app.isPurchasedAllKit = function()
--  print("##### app.isPurchasedAllKit "..tostring(inAppProduct_pro_kit).." "..tostring(inAppProduct_all_levels).." "..tostring(inAppProductFullVersion))
    return (inAppProductFullVersion ~= nil) and (inAppProductFullVersion==1)
end

--Rewarded Videos Flurry

app.getVideoClickCount = function()
    print("app.getVideoClickCount - trying to get videoclickCount ")
    app.incrementVideoClickCount ()
    local valueForEvent = scores:getScore("videosTried"):getValue()
        if (valueForEvent > 50) then
            valueForEvent = "50+" end
    return valueForEvent
end


app.getVideoDoneCount = function()
    print("app.getVideoDoneCount - trying to get videodoneCount ")
    app.incrementVideoWatchedCount ()
    local valueForEvent = scores:getScore("videosDone"):getValue()
        if (valueForEvent > 50) then
            valueForEvent = "50+" end
    return valueForEvent
end


app.incrementVideoClickCount = function()
    print("app.incrementVideoClickCount - trying to increase videoclickCount ")
    scores:getScore("videosTried"):increaseValue(1)
end


app.incrementVideoWatchedCount = function()
    print("app.incrementVideoWatchedCount - trying to increase videodoneCount ")
    scores:getScore("videosDone"):increaseValue(1)
end










srvc = {}

srvc.isAndroid = function()

    print("srvc.isAndroid "..tostring(isAndroid).."")

    return (isAndroid == 1)

end

----------- get the current time  ----------------

app.getCurrentTime = function()
	local currTime = os.date("*t")
	return currTime
end

app.getClockRotation = function(segment)
	local currTime = app.getCurrentTime()
	if segment == "hours" then
		return (currTime.hour * 30 + currTime.min * 0.5)
	end
	if  segment == "minutes" then
		return (currTime.min * 6)
	end
  return 0
end
--------------------- punch in time ---------------------

app.getPunchInTime = function()
	local value
	if (scores:getScore("punchInTimeMinutes"):getValue() < 10 and scores:getScore("punchInTimeMinutes"):getValue() >= 0) then
		value = scores:getScore("punchInTimeHours"):getValue()..":0"..scores:getScore("punchInTimeMinutes"):getValue()
    	return value
	end
	value = scores:getScore("punchInTimeHours"):getValue()..":"..scores:getScore("punchInTimeMinutes"):getValue()
    return value
end
app.getPunchInTimeHours = function()
    return scores:getScore("punchInTimeHours"):getValue()
end
app.getPunchInTimeMinutes = function()
    return scores:getScore("punchInTimeMinutes"):getValue()
end
app.setPunchInTime = function()
    scores:getScore("punchInTimeHours"):setValue(os.date("%H"))
    scores:getScore("punchInTimeMinutes"):setValue(os.date("%M"))
end
app.resetPunchInTimeHours = function()
    return scores:getScore("punchInTimeHours"):reset()
end
app.resetPunchInTimeMinutes = function()
    return scores:getScore("punchInTimeMinutes"):reset()
end


mapController = {}

function mapController.isEvenNumber (val)
    return val % 2
end

mapController.getMapView = function()
    local mv = scores:getScore("mapView"):getValue()
    return mv
end

mapController.setMapView = function()
    local mv = scores:getScore("mapView"):getValue()
    if (mv == 0) then
        scores:getScore("mapView"):setValue(1)
    elseif (mv == 1) then
        scores:getScore("mapView"):setValue(0)
    end
end

mapController.setMapView0 = function()
    scores:getScore("mapView"):setValue(0)
end

--------------------- factory tutorial show  ---------------------

app.getFactoryTutorialShowVariable = function()
    return scores:getScore("factoryTutorialShowVar"):getValue()
end
app.setFactoryTutorialShowVariable = function()
    scores:getScore("factoryTutorialShowVar"):setValue(1)
end
app.resetFactoryTutorialShowVariable = function()
    return scores:getScore("factoryTutorialShowVar"):reset()
end

