-- model.lua

model = {}

model.init = function()
    print("#### level:",model.getCurrentLevel())
    print("#### factory level:",model.getFactoryLevel())
    vars:setVar("factoryLevel",model.getFactoryLevel())

    if (model.getCurrentLevel() > 10) then
        model.setCurrentLevel(1)
    end

    model.m_sledCurrentLevel = model.getCurrentLevel()
    model.m_sledTargetLevel = model.m_sledCurrentLevel
    model.m_sledTargetToFactory = false
    model.m_sledInFactory = false
    model.m_enterOnArrival = false
    model.m_wonMagicTool = false
    model.m_sledTargetCamera = false
end

model.debugmode = function()
    model.setFactoryLevel(1)
    model.setCurrentLevel(6)
    model.setFactoryOpen(true)
    model.setGameComplete(true)
    model.resetAllRewards("MagicTool")
    model.resetAllRewards("Apron")
    model.resetAllRewards("Logo")
    model.resetAllRewards("Treat")
end

model.resetAllRewards = function(toolName)
    i = 1
    while ( scores:exists(toolName.."_"..i) ) do
        score = scores:getScore(toolName.."_"..i)
        newVal = score:getInitialValue()
        print("#### Resetting reward "..toolName.."_"..tostring(i).." to "..newVal)
        score:setValue(newVal)
        i = i+1
    end
end

model.restart = function()
    model.setFactoryLevel(1)
    model.setCurrentLevel(1)
    model.setSledCurrentLevel(1)
    model.setSledTargetLevel(1)
    model.setFactoryOpen(false)
    model.setGameComplete(false)
    model.resetAllRewards("MagicTool")
    model.resetAllRewards("Apron")
    model.resetAllRewards("Logo")
    model.resetAllRewards("Treat")
end

model.openAllLevels = function()
    model.setFactoryLevel(1)
    model.setCurrentLevel(1)
    model.setFactoryOpen(true)
    model.setGameComplete(true)
end

-- wonMagicTool
model.setWonMagicTool = function(val)
    print("######## model.setWonMagicTool "..tostring(val))
    model.m_wonMagicTool = val
end

model.isWonMagicTool = function(val)
    print("######## return model.setWonMagicTool "..tostring(model.m_wonMagicTool))
    return model.m_wonMagicTool
end

-- sledCurrentLevel

model.setSledCurrentLevel = function(level)
    print("##### setSledCurrentLevel "..level)
    model.m_sledCurrentLevel = level
end

model.getSledCurrentLevel = function()
    return model.m_sledCurrentLevel
end


-- sledTargetLevel

model.setSledTargetLevel = function(level)
    print("##### setSledTargetLevel "..level)
    model.m_sledTargetLevel = level
    model.setSledTargetToFactory(false)
end

model.getSledTargetLevel = function()
    return model.m_sledTargetLevel
end

-- sledInFactory

model.setSledInFactory = function(val)
    print("##### setSledInFactory "..tostring(val))
    model.m_sledInFactory = val
end

model.isSledInFactory = function()
    return model.m_sledInFactory
end

-- sledTargetToFactory

model.setSledTargetToFactory = function(val)
    print("##### setSledTargetToFactory "..tostring(val))
    model.m_sledTargetToFactory = val
end

model.isSledTargetToFactory = function()
    return model.m_sledTargetToFactory
end


-- Factory level

model.getFactoryLevel = function()
    value = scores:getScore("factoryLevel"):getValue()
    return value
end

model.setFactoryLevel = function(level)
    print("##### setFactoryLevel",tostring(level))
    scores:getScore("factoryLevel"):setValue(level)
    vars:setVar("factoryLevel",level);
end

-- Current level

model.getCurrentLevel = function()
    return scores:getScore("level"):getValue()
end

model.setCurrentLevel = function(level)
    print("Setting current level to "..level)
    score = scores:getScore("level"):setValue(level)
end

-- Factory Open

model.isFactoryOpen = function()
    score = scores:getScore("factoryOpen")
    value = score:getValue()
    return (value == 1)
end

model.setFactoryOpen = function(open)
    score = scores:getScore("factoryOpen")
    if (open) then
        score:setValue(1)
    else
        score:setValue(0)
    end
end

-- Current level

model.isGameComplete = function()
    return (scores:getScore("gameComplete"):getValue() == 1)
end

model.setGameComplete = function(complete)
    if (complete) then
        scores:getScore("gameComplete"):setValue(1)
    else
        scores:getScore("gameComplete"):setValue(0)
    end
end

-- Current level

model.setRewardWon = function(rewardName)
    print("### model.setRewardWan "..tostring(rewardName))
    scores:getScore(rewardName):setValue(1)
end

model.isRewardAvailiable = function(rewardName)
    print("### checking if reward is availiable :"..rewardName)
    val = (scores:getScore(rewardName):getValue() == 1)
    print("### checking if reward is availiable :"..rewardName.." return:"..tostring(val))
    return val
end

-- Sled Target Camera

model.setSledTargetCamera = function(value)
    model._sledTargetCamera = value
end

app.isSledTargetCamera = function()
    return model._sledTargetCamera
end

model.resetAllScores = function()
    print("app.resetScores - reseting all scores...")
    scores:reset()
end

